#import <Foundation/Foundation.h>
#import <GameShield/QNDAsyncSocket.h>

@interface GameshieldManager : NSObject <QNDAsyncSocketDelegate>

// 单例方法
+ (instancetype)sharedInstance;

- (int32_t)start:(const char *)sdkKey;
- (int32_t)start:(const char *)sdkKey recommendCode:(const char *)recommendCode;
- (NSInteger)getActiveClients __attribute((__annotate__(("fla"))));
- (NSInteger)getActiveClients:(int)type __attribute((__annotate__(("fla"))));
- (void)addBytesTransferred:(long)bytesRead __attribute((__annotate__(("fla"))));
- (void)tryGetDynamicIP;
- (void)tryTestConnectivity;
- (void)startTestConnectivity __attribute((__annotate__(("fla"))));
- (void)startSyncStatus:(NSString *)opt_type __attribute((__annotate__(("fla"))));
- (void)stop;
- (const char *)getUniqueID;
- (const char *)tryGetLocalIP;
- (void)setTryConnect:(BOOL)value;
- (NSString *)getMd5Hash:(NSString *)input;
- (BOOL)checkConnectionAllowed:(NSString *)ip num:(NSInteger)num __attribute((__annotate__(("fla"))));
- (void)presentAlert_disallowConnection:(NSString *)ip port:(uint16_t)port __attribute((__annotate__(("fla"))));
- (BOOL)checkReachedLimited __attribute((__annotate__(("fla"))));
- (void)presentAlert_reachedLimited __attribute((__annotate__(("fla"))));
- (int)getLimitNum:(NSString *)ip __attribute((__annotate__(("fla"))));
- (int)getIPUsage:(NSString *)ip __attribute((__annotate__(("fla"))));
- (void)setIPUsage:(NSString *)ip value:(int)value __attribute((__annotate__(("fla"))));
- (NSString *)getIPPort:(int)index __attribute((__annotate__(("fla"))));
- (void)setCheckLocalTimeFlag:(BOOL)flag __attribute((__annotate__(("fla"))));
- (BOOL)getSNIOpen __attribute((__annotate__(("fla"))));

@end

#ifdef __cplusplus
extern "C" {
#endif

int GameshieldManager_start(const char *sdkKey);

int GameshieldManager_startWithCode(const char *sdkKey, const char *recommendCode);

void GameshieldManager_stop(void);

const char * GameshieldManager_getUniqueID(void);

void GameshieldManager_tryGetDynamicIP(void);

void GameshieldManager_tryTestConnectivity(void);

const char * GameshieldManager_tryGetLocalIP(void);

#ifdef __cplusplus
}
#endif
